import 'dart:html';
import 'package:flutter/widgets.dart';
import 'dart:ui' as ui;

class MultiplatformWebview extends StatefulWidget {
  const MultiplatformWebview({
    @required this.src,
    @required this.id,
  });

  final String src;
  final String id;

  @override
  _MultiplatformWebviewState createState() => _MultiplatformWebviewState();
}

class _MultiplatformWebviewState extends State<MultiplatformWebview> {
  final IFrameElement _iframeElement = IFrameElement();

  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    String currentSrc = widget.src;

    // ignore: undefined_prefixed_name
    ui.platformViewRegistry.registerViewFactory(
      'iframeElement-${widget.id}',
      (int viewId) => _iframeElement,
    );

    //_iframeElement.height = '500';
    //_iframeElement.width = '500';

    if (widget.src.toUpperCase().contains("HTML")) {
      currentSrc = """
                  <!DOCTYPE html>
                  <html lang="en">
                    <head>
                        <meta charset="UTF-8">
                        <meta name="viewport" content="width=device-width, initial-scale=0.2">
                        <title>Document</title>
                    </head>
                    <body>
                      ${widget.src}
                    </body>
                  </html>
                    """;

      _iframeElement.srcdoc = currentSrc;
    } else {
      _iframeElement.src = currentSrc;
    }

    _iframeElement.style.border = 'none';

    return Container(
      child: HtmlElementView(
        key: UniqueKey(),
        viewType: 'iframeElement-${widget.id}',
      ),
    );
  }
}
